
/*
	Comandos para criar padres de fundo
*/

#include <tk.h>
#define min(x,y) ((x)<(y) ? (x) : (y))

#define RED(p,x,y) ((p)->pixelPtr[(y)*(p)->pitch+(x)*(p)->pixelSize+(p)->offset[0]])
#define GREEN(p,x,y) ((p)->pixelPtr[(y)*(p)->pitch+(x)*(p)->pixelSize+(p)->offset[1]])
#define BLUE(p,x,y) ((p)->pixelPtr[(y)*(p)->pitch+(x)*(p)->pixelSize+(p)->offset[2]])

int Pattern( ClientData clientData, 
	Tcl_Interp *interp, int argc, char **argv ) {
	Tk_PhotoHandle img;
	Tk_PhotoImageBlock imgblk;
	XColor *bcolor,*ecolor;
	int limx, limy, x, y, x1;
	int xx,yy,r,q,t,limr;
	int bred,bgreen,bblue;
	int ered,egreen,eblue;
	int dred,dgreen,dblue;
	unsigned char *pred,*pgreen,*pblue;
	Tk_Window tkwin;
	int patkind,pixofs,linofs;
	
	if (argc != 5 ) {
		Tcl_AppendResult( interp,"Syntax: ",argv[0],
			" image begin_color end_color pattern_kind",0);
		return TCL_ERROR;
	}
	img = Tk_FindPhoto( interp, argv[1] );
	Tk_PhotoGetSize (img,&limx,&limy);
	Tk_PhotoGetImage(img,&imgblk);

/********* obtem cores inicial e final do gradiente *************/
	tkwin = Tk_MainWindow(interp);
	bcolor = Tk_GetColor(interp,tkwin,argv[2]);
	ecolor = Tk_GetColor(interp,tkwin,argv[3]);

	bred = bcolor->red;
	bgreen = bcolor->green;
	bblue = bcolor->blue;
	ered = ecolor->red;
	egreen = ecolor->green;
	eblue = ecolor->blue;

/**************** obtem tipo de padro desejado ****************/	
	Tcl_GetInt(interp,argv[4],&patkind);

/************ construiremos a imagem com o padro **************

A ideia aqui  ter uma funo F(x,y) no plano, com valores no 
intervalo [0.0,1.0] tal que as 3 componentes RGB do pixel  dada
por R = F(x,y) * Rb + (1-F(x,y)) * Re, onde Rb e Re so 
as componentes das cores limtrofes dads.
*/
	pixofs = imgblk.pixelSize;
	linofs = imgblk.pitch;
	limr = limx + limy;

	switch (patkind) {
	case 0:
		for (x=0;x<limx;x++) {
			dred = min((bred * x + ered * (limx-x))/(limx*256),255);
			dgreen = min((bgreen * x + egreen * (limx-x))/(limx*256),255);
			dblue = min((bblue * x + eblue * (limx-x))/(limx*256),255);
			pred = imgblk.pixelPtr+(x*pixofs+imgblk.offset[0]);
			pgreen = imgblk.pixelPtr+(x*pixofs+imgblk.offset[1]);
			pblue = imgblk.pixelPtr+(x*pixofs+imgblk.offset[2]);
			for (y=0;y<limy;y++) {
				*pred = dred; pred+=linofs;
				*pgreen = dgreen; pgreen+=linofs;
				*pblue = dblue; pblue+=linofs;
			}		
		}
		break; 
	case 1:
		for (y=0;y<limy;y++) {
			dred = min((bred * y + ered * (limy-y))/(limy*256),255);
			dgreen = min((bgreen * y + egreen * (limy-y))/(limy*256),255);
			dblue = min((bblue * y + eblue * (limx-y))/(limy*256),255);
			for (x=0;x<limx;x++) {
				RED(&imgblk,x,y) = dred;
				GREEN(&imgblk,x,y) = dgreen; 
				BLUE(&imgblk,x,y) = dblue;
			}		
		}
		break; 
	case 2:
		for (y=0;y<limy;y++) {
			for (x=0;x<limx;x++) {

				r = x + y;
				RED(&imgblk,x,y) = min((bred*r + ered*(limr-r))/(limr*256),255);
				GREEN(&imgblk,x,y) = min((bgreen*r + egreen*(limr-r))/(limr*256),255);
				BLUE(&imgblk,x,y) = min((bblue*r + eblue*(limr-r))/(limr*256),255);
			}		
		}
		break; 
	case 3:
		for (y=0;y<limy;y++) {
			for (x=0;x<limx;x++) {
				r = x + y;
				RED(&imgblk,x,limy-y-1) = min((bred*r + ered*(limr-r))/(limr*256),255);
				GREEN(&imgblk,x,limy-y-1) = min((bgreen*r + egreen*(limr-r))/(limr*256),255);
				BLUE(&imgblk,x,limy-y-1) = min((bblue*r + eblue*(limr-r))/(limr*256),255);
			}		
		}
		break; 
	case 4:
		for (x=0;x<limx;x++) {
			if (x<limx/2) x1=x*2; else x1=(limx-x)*2;
			dred = min((bred * x1 + ered * (limx-x1))/(limx*256),255);
			dgreen = min((bgreen * x1 + egreen * (limx-x1))/(limx*256),255);
			dblue = min((bblue * x1 + eblue * (limx-x1))/(limx*256),255);
			for (y=0;y<limy;y++) {
				RED(&imgblk,x,y) = dred;
				GREEN(&imgblk,x,y) = dgreen; 
				BLUE(&imgblk,x,y) = dblue;
			}		
		}
		break; 
	case 5:
		for (y=0;y<limy;y++) {
			if (y<limy/2) x1=y*2; else x1=(limy-y)*2;
			dred = min((bred * x1 + ered * (limy-x1))/(limy*256),255);
			dgreen = min((bgreen * x1 + egreen * (limy-x1))/(limy*256),255);
			dblue = min((bblue * x1 + eblue * (limy-x1))/(limy*256),255);
			for (x=0;x<limx;x++) {
				RED(&imgblk,x,y) = dred;
				GREEN(&imgblk,x,y) = dgreen; 
				BLUE(&imgblk,x,y) = dblue;
			}		
		}
		break; 
	case 6:
		q = (limx*limx+limy*limy)/(limx+limy);
		t = (limx+limy)*128;
		for (y=0;y<limy;y++) {
			for (x=0;x<limx;x++) {
				xx = (2*x-limx)*(2*x-limx);
				yy = (2*y-limy)*(2*y-limy);
				r = (xx+yy)/(limx+limy);
				RED(&imgblk,x,y) = min((r*bred+(q-r)*ered)/t,255); 
				GREEN(&imgblk,x,y) =  min((r*bgreen+(q-r)*egreen)/t,255);
				BLUE(&imgblk,x,y) = min((r*bblue+(q-r)*eblue)/t,255);
			}		
		}
		break; 
	}
	Tk_PhotoPutBlock(img,&imgblk,0,0,limx,limy);
	return TCL_OK;
}
Sld_Init( Tcl_Interp *interp ) {
	Tcl_PkgProvide(interp,"Sld","1.0");
	Tcl_CreateCommand(interp,"pattern",Pattern,
		(ClientData) Tk_MainWindow(interp),
		(Tcl_CmdDeleteProc *) NULL);
		
	return TCL_OK;
}

