#
# makeImage -- optionally uses ImageMagick's convert utility
# to change image data to a suitable format for tk importing
#
proc makeImage {  } {
	global sld sldi cvt
	set cvt(abort) 0
	if {![info exists cvt(file)]} {
		set cvt(file) ""
		foreach i {crop despeckle dither emboss enhance transparent} {
			set cvt($i) 0
		}
		set cvt(tcolor) "#000000"
		set cvt(x) 16
		set cvt(y) 16
	}
	toplevel .mki
	wm transient .mki .	
	pack [frame .mki.fl -relief sunken] \
	     [frame .mki.fr -relief groove] -side left
	pack [frame .mki.fr.opt -relief groove] \
		 [label .mki.fr.l -text options: -relief raised] \
		 [frame .mki.fr.op1 -highlightthickness 0] \
		 [frame .mki.fr.op2 -highlightthickness 0] \
		 [frame .mki.fr.op3 -highlightthickness 0] \
		 [frame .mki.fr.op4 -highlightthickness 0] \
		 [frame .mki.fr.op5 -highlightthickness 0] \
		 -expand 1 -fill x -side top
	pack \
		[label .mki.fl.lb -text format: -relief raised] \
		-expand 1 -fill both -ipadx 10 -ipady 10 -side top
	pack \
		[frame .mki.fl.a] \
		[frame .mki.fl.b] -side left
		
	foreach r {auto gif jpeg fax pcd} {
		pack [radiobutton .mki.fl.a.$r -text $r \
			-variable cvt(type) -value $r] -side top
	}
	foreach r {eps epsf epsi tiff xpm} {
		pack [radiobutton .mki.fl.b.$r -text $r \
			-variable cvt(type) -value $r] -side top
	}
	.mki.fl.a.auto invoke

	pack \
		[label .mki.fr.opt.l -text file:] \
		[entry .mki.fr.opt.e -textvariable cvt(file)] \
		[button .mki.fr.opt.b -text browse -command \
			{ set cvt(file) [tk_getOpenFile -initialfile $cvt(file)]} ] \
				-side left -fill x
	pack \
		[checkbutton .mki.fr.op1.c -text crop -variable cvt(crop)] \
		[entry .mki.fr.op1.x -width 4 -textvariable cvt(x)] \
		[label .mki.fr.op1.vs -text X -highlightthickness 0] \
		[entry .mki.fr.op1.y -width 4 -textvariable cvt(y)] \
			-side left -fill x -expand 1
	pack \
		[checkbutton .mki.fr.op2.c1 -text despeckle \
			-variable cvt(despeckle)] \
		[checkbutton .mki.fr.op2.c2 -text dither \
			-variable cvt(dither)] -side left -fill x -expand 1
	pack \
		[checkbutton .mki.fr.op3.c1 -text emboss \
			-variable cvt(emboss)] \
		[checkbutton .mki.fr.op3.c2 -text enhance \
			-variable cvt(enhance)] -side left -fill x -expand 1
	pack \
		[checkbutton .mki.fr.op4.c1 -text "transparent color" \
			-variable cvt(transparent)] \
		[entry .mki.fr.op4.e -width 7 -textvariable cvt(tcolor)] \
			-side left -fill x -expand 1
	pack \
		[button .mki.fr.op5.done -text done \
			-command { destroy .mki }] \
		[button .mki.fr.op5.clear -text cancel \
			-command { set cvt(abort) 1; destroy .mki }] \
			-side left -expand 1 -fill x

	centerWindow .mki
	raise .mki
	tkwait window .mki

	if {$cvt(abort)} { return "" }

## determine filename to save, in the same directory of the slide
#	regexp "(.*/)(.*)" $sld(currfile) fullname path fname
	set img i$sld(imgcnt)
	incr sld(imgcnt)

## if we cannot do with internal command...
#	set result [catch {image create photo $img -file $cvt(file)}]
## set options for conversion
	set cvopt ""
	foreach opt {despeckle dither emboss enhance} {
		if {$cvt($opt)} {
			append cvopt " -$opt"
		}
	}
	if {$cvt(crop)} {
		append cvopt " -crop $cvt(x)x$cvt(y)"
	}
	if {$cvt(transparent)} {
		append cvopt " -transparency $cvt(tcolor)"
	}
#	if {$result} {
## here cv.sh is a command to convert to a base64-encoded gif file

		set imgdata [exec $sld(dir)/cv.sh $cvopt $cvt(file)] 
    	image create photo $img -data $imgdata
#	}
## save image data to a variable (so it can be embedded in the slide)
	set sldi($img) $imgdata 
	set img
}
