proc getPrintOptionsDone {ret} {
	global pr sld
	set pr(options) ""
	if {$ret} {
		append pr(options) " -colormode $pr(mode)"
		append pr(options) " -rotate $pr(rotate)"
### convert width (inches) to postscript units (1/72 in)
		append pr(options) " -pagewidth [expr $pr(width) * 72]"
### set drawing size to print
		set sclr [lindex [.c.c config -scrollregion] 4] 
		append pr(options) " -width [lindex $sclr 2] -height [lindex $sclr 3]"
		if {$pr(file)} {
			set fd [open $sld(dir)/tmp/tofile w]
			for {set iSlide 1} {$iSlide <= $sld(page,max)} {incr iSlide} {
				gotoSlide $iSlide
				puts $fd [eval .c.c postscript -x 0 -y 0 $pr(options)] 
			}
			close $fd
			eval exec cp $sld(dir)/tmp/tofile /home/root/rildo-tmp.ps 
			if { [catch {exec $sld(dir)/canvas2ps.pl $sld(dir)/tmp/tofile > $pr(filename).ps}] } {
				tk_dialog .dlg "Problems1" \
					"1-There has been an error printing \
the current presentation to the specified file. Please check that\
you are within quota limits." "" 0 OK}
		} else {
			set f [open $sld(dir)/tmp/printer w]
			for {set iSlide 1} {$iSlide <= $sld(page,max)} {incr iSlide} {
				gotoSlide $iSlide
				puts $f [eval .c.c postscript -x 0 -y 0 $pr(options)]
			}
			close $f
			
			if { [catch {exec $sld(dir)/canvas2ps.pl $sld(dir)/tmp/printer \
						> $sld(dir)/tmp/printer.ps ; lpr $sld(dir)/tmp/printer.ps}]} {
				tk_dialog .dlg "Problems2" \
					"2-There has been an error printing \
the current presentation to the specified file. Please check that\
you are within quota limits." "" 0 OK
			}
		}
	}
	destroy .pr
}

proc getPrintOptions {} {
	global pr sld
	toplevel .pr
	wm title .pr Print
	wm transient .pr .
	frame .pr.ft
	frame .pr.ft.l -bd 3 -relief sunken
	label .pr.ft.l.title -text "Color mode"
	radiobutton .pr.ft.l.color -text Color \
		-variable pr(mode) -value color
	radiobutton .pr.ft.l.gray -text Gray \
		-variable pr(mode) -value gray 
	radiobutton .pr.ft.l.mono -text "B&W" \
		-variable pr(mode) -value mono
	.pr.ft.l.color invoke
	pack .pr.ft.l.title .pr.ft.l.color .pr.ft.l.gray .pr.ft.l.mono -side top
	frame .pr.ft.r
	radiobutton .pr.ft.r.land  -bitmap @$sld(idir)/landscape.xbm \
		-variable pr(rotate) -value 1
	radiobutton .pr.ft.r.port  -bitmap @$sld(idir)/portrait.xbm \
		-variable pr(rotate) -value 0
	.pr.ft.r.land invoke
	pack .pr.ft.r.port .pr.ft.r.land -side top 
	scale .pr.ft.width -resolution 0.1 -showvalue 1 \
		-from 5 -to 14 -variable pr(width) \
		-label "Drawing width (inches)" -orient horizontal -digits 3
	.pr.ft.width set 11.0 
	pack .pr.ft.l -side left
	pack .pr.ft.r -side top
	pack .pr.ft.width -expand 1 -fill x
	frame .pr.fm
	checkbutton .pr.fm.b -text "To file" \
		-variable pr(file) -onvalue 1 -offvalue 0
	entry .pr.fm.e -width 30 -textvariable pr(filename)
	pack .pr.fm.b .pr.fm.e -side left -fill x -expand 1
	frame .pr.fb
	button .pr.fb.cancel -text Cancel -command { getPrintOptionsDone 0 }
	button .pr.fb.print -text OK -command { getPrintOptionsDone 1 }
	pack .pr.fb.print .pr.fb.cancel -side left -fill x -expand 1
	pack .pr.ft .pr.fm .pr.fb -fill x -expand 1 -side top
	centerWindow .pr
	raise .pr
}

proc fileExport {} {
	global sld
	toplevel .exp
	wm transient .exp .
	frame .exp.f
	radiobutton .exp.f.eps -text "PostScript(c)" \
		-variable fmt -value eps
	radiobutton .exp.f.xfig -text XFig -variable fmt -value xfig \
		-state disabled
	radiobutton .exp.f.xpm -text xpm -variable fmt -value xpm \
		-state disabled
	.exp.f.eps invoke
	pack .exp.f.eps .exp.f.xfig .exp.f.xpm -side left
	frame .exp.f1
	checkbutton .exp.f1.z -text gzipped -variable gzipped
	entry .exp.f1.fn -width 40
	pack .exp.f1.z .exp.f1.fn -side left
		# puts $fd [.c.c postscript]
		update
	frame .exp.f2
	button .exp.f2.export -text OK -command {
		set ffile [.exp.f1.fn get]
		set fd [open $ffile w]
		for {set iSlide 1} {$iSlide <= $sld(page,max)} {incr iSlide} {
			gotoSlide $iSlide
			if {[string compare $sld(orientation) "Landscape"] == 0} {
				puts $fd [.c.c postscript -rotate 1]
			} else {
				puts $fd [.c.c postscript]
			}
		}
		close $fd
		if [catch \
			[exec $sld(dir)/canvas2ps.pl \
				$ffile > $ffile.ps] 
		] {
			tk_dialog .dlg "Problems3" \
"3-There has been an error exporting \
the current presentation. Please check that you \
are within quota limits." "" 0 OK
		}
		if [catch [exec rm $ffile]] {tk_dialog .dlg "Problems4" "4-Not able to \
delete temporary file $ffile, please do it by hand" "" 0 OK}
		destroy .exp
	} 
	button .exp.f2.cancel -text Cancel -command {destroy .exp}
	button .exp.f2.browse -text "Browse..." -command {
		.exp.f1.fn delete 0 end; .exp.f1.fn insert end [tk_getSaveFile]}
	pack .exp.f2.export .exp.f2.browse .exp.f2.cancel \
		-side left -anchor c
	pack .exp.f .exp.f1 .exp.f2 -side top
	centerWindow .exp
	raise .exp
}
