
proc rulerMkTab {x y} {
    .c.c create polygon $x $y [expr $x+10] [expr $y+10] \
	    [expr $x-10] [expr $y+10]
}

proc rulerMoveTab {x y} {
	global mrk
    .c.c move active [expr $x-$mrk(x)] [expr $y-$mrk(y)]
    set mrk(x) $x
    set mrk(y) $y
}

proc makeRulers { } {
	global sld rulerpos
    if {$sld(multi)} { return }

	.c.c delete -tags hruler
	.c.c delete -tags vruler

	if {$sld(rulersenable)} {
		set rulerpos(x) -30
		set rulerpos(y) -30

# each sld(ticks) is a list with the following format:
# { minzoom { ticks relative positions } delta_x 
#   mintxtzoom tickheight decs txtdisp }

# horizontal ruler 
foreach tick $sld(ticks) {
    if {[lindex $tick 0] <= $sld(scale)} {
        set x 0.0
        set xabs 0.0
        while { [winfo pixels .c.c ${x}c] < [expr $sld(dwidth) * $sld(scale)] } {
            foreach xi [lindex $tick 1] {
                .c.c create line [expr $x + $xi * $sld(scale)]c -0.2c \
                    [expr $x + $xi * $sld(scale)]c \
                    [expr -0.2 - [lindex $tick 4]]c \
                    -width 1 -tags hruler 
                if {[lindex $tick 3] <= $sld(scale)} {
                    set mtext [format "%[lindex $tick 5]f" [expr $xabs+$xi]]
                    .c.c create text [expr $x + $xi * $sld(scale) \
                        + 0.15]c -[expr [lindex $tick 6]-0.05]c \
                        -font [lindex $tick 7] -text $mtext \
                        -anchor sw -tags hruler
                }
            }
            set x [expr $x + [lindex $tick 2] * $sld(scale)]
            set xabs [expr $xabs + [lindex $tick 2]]
        }
    }
}
# vertical ruler
foreach tick $sld(ticks) {
    if {[lindex $tick 0] <= $sld(scale)} {
        set x 0.0
        set xabs 0.0
        while { [winfo pixels .c.c ${x}c] < [expr $sld(dheight)*$sld(scale)] } {
            foreach xi [lindex $tick 1] {
                .c.c create line -0.2c [expr $x + $xi * $sld(scale)]c\
                    [expr -0.2 - [lindex $tick 4]]c \
                    [expr $x + $xi * $sld(scale)]c \
                    -width 1 -tags vruler 
                if {[lindex $tick 3] <= $sld(scale)} {
                    set mtext [format "%[lindex $tick 5]f" [expr $xabs+$xi]]
                    set shift [font measure [lindex $tick 7] $mtext]
                   .c.c create text -[expr 0.45+[lindex $tick 6]]c-$shift\
                        [expr $x + $xi * $sld(scale)]c \
                        -font [lindex $tick 7] -text $mtext \
                        -anchor sw -tags vruler
                }
            }
            set x [expr $x + [lindex $tick 2] * $sld(scale)]
            set xabs [expr $xabs + [lindex $tick 2]]
        }
    }
}
	} 
    setupCanvasSize
    moveRulers
}

proc moveRulers {} {
	global sld rulerpos
    if {$sld(multi)} { return }
	if {$sld(rulersenable)} {
		set sr [.c.c cget -scrollregion]
		set x0 [winfo pixels .c.c [lindex $sr 0]]
		set y0 [winfo pixels .c.c [lindex $sr 1]]
		set x1 [winfo pixels .c.c [lindex $sr 2]]
		set y1 [winfo pixels .c.c [lindex $sr 3]]
## get top/left side of canvas view
		set x [expr [lindex [.c.c xview] 0]*($x1-$x0)+$x0] 
		set y [expr [lindex [.c.c yview] 0]*($y1-$y0)+$y0]
		set dx [expr $x - $rulerpos(x)]
		set dy [expr $y - $rulerpos(y)]
		set rulerpos(x) $x
		set rulerpos(y) $y
		.c.c move hruler 0 $dy
		.c.c move vruler $dx 0
		.c.c raise hruler
		.c.c raise vruler
	}
}

