proc finishToolbarConfig { } {
        global sld sldtool
        set sld(menulist) {}
        destroy .tb
}

proc setToolbarButton { } {
        global sld sldtool
        set n [.tb.sc get]
        set icon [.tb.i.e get]
        set barlist [pack slaves .bar]
        set target [lindex $barlist [expr $n + 1]]
        catch { destroy .bar.b$n .bar.s$n }
        catch { image delete ib$n }
        if {$sld(menuindex) == 0} {
                pack [frame .bar.s$n -width 10] -before $target -side left
                set sld(toolbar) [lreplace $sld(toolbar) $n $n {}]
        } else {
                set item [lindex $sld(menulist) [expr $sld(menuindex)-1]]
                set m [lindex $item 1]
                set i [lindex $item 2]
                set sld(toolbar) [lreplace \
                        $sld(toolbar) $n $n [list $icon $m $i]]
                image create photo ib$n -file $sld(idir)/$icon
                pack [button .bar.b$n -image ib$n \
                        -command "$m invoke $i"] -before $target -side left
        }
}

proc showToolbarButton { n } {
        global sld sldtool
        .tb.i.e delete 0 end
        set btn [lindex $sld(toolbar) $n]
        .tb.w.lb selection clear 0 end
        if {$btn != ""} {
                if {[lindex $btn 0] == ""} {
                        set desc **separator**
                        .tb.w.lb selection set 0
                        set sld(menuindex) 0
                } else {
                        set i $sldtool([lindex $btn 1],[lindex $btn 2])
                        set desc [lindex $i 0]
                        .tb.w.lb selection set [lindex $i 1]
                        set sld(menuindex) [lindex $i 1]
                        .tb.i.e insert end [lindex $btn 0]
                }
        }
        catch { .tb.w.lb see [.tb.w.lb curselection] }
}

proc changeToolbarIcon { } {
        global sld sldtool
        set fn [tk_getOpenFile -initialdir $sld(idir) \
                -initialfile [.tb.i.e get]]
        regexp (.*/)(.*) $fn fullname path filename
        .tb.i.e delete 0 end
        .tb.i.e insert end $filename
}

#
# editToolbar -- user configuration dialog for the toolbar
#
proc editToolbar { } {
	global sld sldtool

	set sld(menulist) [menuTree .mb]
# the version with arrays is faster! (tcl uses a hashing algorithm)
        set n 1
        foreach item $sld(menulist) {
                set m [lindex $item 1]
                set i [lindex $item 2]
                set sldtool($m,$i) [list [lindex $item 0] $n]
                incr n
        }
	toplevel .tb 
        wm title .tb "Slidedraw Toolbar Config"
        label .tb.lb -font {Utopia 16 bold} -text "Toolbar Configuration"
        scale .tb.sc -digits 2 -command showToolbarButton \
                -from 0 -to 19 -length 300 \
                -tickinterval 5.0 -orient horizontal
	frame .tb.w
        listbox .tb.w.lb -width 40 -height 7 \
                -relief sunken -bd 2 -selectmode single\
                -yscrollcommand [list .tb.w.sb set]
        scrollbar .tb.w.sb -orient vertical -command [list .tb.w.lb yview]
        bind .tb.w.lb <1> {set sld(menuindex) [%W nearest %y]}
        pack .tb.w.lb .tb.w.sb -side left -fill y
        frame .tb.i
        label .tb.i.lb -text "Icon:" -highlightthickness 0
        entry .tb.i.e
        button .tb.i.b -text browse -command changeToolbarIcon
        pack .tb.i.lb .tb.i.e .tb.i.b -side left -padx 5 -pady 5 
        .tb.w.lb insert end "**separator**"
        foreach i $sld(menulist) {
	        .tb.w.lb insert end [lindex $i 0]
        }
        frame .tb.bts
        button .tb.bts.b1 -text "set button" -command setToolbarButton
	button .tb.bts.b2 -text dismiss -command finishToolbarConfig
        pack .tb.bts.b1 .tb.bts.b2 -side left
	pack .tb.lb .tb.sc .tb.w .tb.i .tb.bts -side top
	update
	raise .tb
	focus .tb
}

#
# menuTree -- generates a tree with all menu/submenu options and
# the respective command it executes
#
proc menuTree { m {sm {}} } {
        global sld sldtool
	if {[winfo class $m] == "Menubutton"} {
		return [menuTree [lindex [$m config -menu] 4]\
			"[lindex [$m config -text] 4]/"]
	}
	if {[winfo class $m] == "Menu"} {
		set mlist {}
		for {set i 0} {$i <= [$m index last]} {incr i} {
			if {[regexp command|checkbutton|radiobutton \
				[$m type $i]]} {
                                        lappend mlist [list "$sm[$m entrycget $i -label]" $m $i]
			} elseif {[$m type $i] == "cascade"} {
				set mlist [concat $mlist [menuTree \
					[$m entrycget $i -menu] \
					"$sm[$m entrycget $i -label]/"]]
			}
		}
		return $mlist
	}
	if {$sm == ""} {
		set mlist {}
		foreach child [winfo children $m] {
			set mlist [concat $mlist [menuTree $child]]
		}
		return $mlist
	}
}

